// filesrc.h
// StreamInputSource wrapped on a FILE
// copyright SafeTP Development Group, Inc., 2000  Terms of use are as specified in license.txt

#ifndef __FILESRC_H
#define __FILESRC_H

#include "inputsrc.h"      // StreamInputSource
#include <stdio.h>         // FILE

class FileInputSource : public StreamInputSource {
public:     // data
  FILE *file;       // ordinary FILE*

public:     // funcs
  FileInputSource(FILE *f) : file(f) {}

  virtual int read(char *buffer, int buflen);
};


class FileOutputDest : public StreamOutputDest {
public:     // data
  FILE *file;       // ordinary FILE*

public:     // funcs
  FileOutputDest(FILE *f) : file(f) {}

  virtual void write(char const *data, int len);
};

#endif // __FILESRC_H

