// getserv.cpp
// program to query getservbyname()
// copyright SafeTP Development Group, Inc., 2000  Terms of use are as specified in license.txt

#include <netdb.h>       // getservbyname
#include <stdio.h>       // printf, perror
#include <netinet/in.h>  // ntonh{l,s}

int main(int argc, char *argv[])
{
  if (argc < 2) {
    printf("usage: %s service-name\n", argv[0]);
    return 0;
  }

  struct servent *se = getservbyname(argv[1], "tcp");
  if (se) {
    printf("name: %s\n", se->s_name);
    for (char **a = se->s_aliases; *a != NULL; a++) {
      printf("alias: %s\n", *a);
    }

    int port = ntohs((short)se->s_port);
#if 0
    if (sizeof(se->s_port) == sizeof(long)) {
      printf("using ntohl\n");
      port = ntohl(se->s_port);
    }
    else if (sizeof(se->s_port) == sizeof(short)) {
      printf("using ntohs\n");
      port = ntohs(se->s_port);
    }
    else {
      printf("can't use htohl or htohs...\n");
      return 2;
    }
#endif // 0

    printf("port: %d\n", port);
    printf("protocol: %s\n", se->s_proto);
    return 0;
  }

  else {
    perror("getservbyname");
    return 2;
  }
}
