// makekeys.h
// interface to makekeys module for when making keys is not
//   a stand-alone activity
// Copyright 1999, Dan Bonachea, Scott McPeak  Terms of use are as specified in license.txt.

#ifndef __MAKEKEYS_H
#define __MAKEKEYS_H

#include "typ.h"      // bool

// elgamalParams: samed in selgamal.h, e.g. ElGamal_1024bit_parameters
// elgamalLen: length in bits of ElGamal keys (e.g. 1024)
// forceProtected: when true, and registry is being used, HKEY_LOCAL_MACHINE is
//                 used instead of HKEY_CURRENT_USER
bool GenerateElgamalKey(char const * const * elgamalParams,
                        int elgamalLen,
                        bool forceProtected=false);

#endif // __MAKEKEYS_H

